﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private bc As BitmapCreator
	Private xiv As B4XView
	Private XZero As Int = 0
	Private VerticalLineGap As Int = 40
	Private HalfVerticalLineGap As Int = 20
	Private HorizontalLineGap As Int = 20
	Private CurrentX As Float = -1
	Private MinY = -50, MaxY = 50 As Float
	Public ValueColor As Int = 0xffff0000
	Private cvs As B4XCanvas
	Private fnt As B4XFont
	Private GridHeight As Int
	Private GridColor As Int
	Private BackgroundColor As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	BackgroundColor = xui.Color_White
	GridColor = xui.Color_Gray
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Dim PanelForCvs As B4XView = xui.CreatePanel("")
	fnt = Lbl.Font
	PanelForCvs.SetLayoutAnimated(0, 0, 0, 1, 1)
	cvs.Initialize(PanelForCvs)
	Dim r As B4XRect = cvs.MeasureText("9999", fnt)
	Log(r)
	Dim iv As ImageView
	iv.Initialize("")
	xiv = iv
	mBase.AddView(xiv, 1dip, 1dip, mBase.Width - 3dip, mBase.Height - 3dip)
	Dim scale As Float = 100dip / 100
	bc.Initialize(xiv.Width / scale, xiv.Height / scale)
	bc.FillRect(BackgroundColor, bc.TargetRect)
	GridHeight = bc.mHeight - Ceil(r.Height / scale + 2)
	
	PanelForCvs.SetLayoutAnimated(0, 0, 0, r.Width,  bc.mHeight - GridHeight)
	cvs.Resize(PanelForCvs.Width, PanelForCvs.Height)
	DrawGrid(0, bc.mWidth - 1)
	CurrentX = bc.mWidth - 5
	Refresh
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Public Sub AddPoint(dx As Float, y As Float)
	If CurrentX >= bc.mWidth - 1 Then
		Dim MovingSize As Int = 1
		Dim r As B4XRect
		r.Initialize(MovingSize, 0, bc.mWidth, bc.mHeight)
		bc.DrawBitmapCreator(bc, r, 0, 0, True)
		XZero = XZero + MovingSize
		DrawGrid(bc.mWidth - MovingSize, bc.mWidth - 1)
		CurrentX = CurrentX - MovingSize
	End If
	CurrentX = CurrentX + dx
	Dim vy As Int = YValueToYPoint(y)
	bc.SetColor(CurrentX, vy , ValueColor)
	If vy < GridHeight - 1 Then
		bc.SetColor(CurrentX, vy + 1, ValueColor)
	End If
End Sub

Public Sub Refresh
	xiv.SetBitmap(bc.Bitmap)
End Sub


Private Sub YValueToYPoint(y As Float) As Int
	Return Max(0, Min(GridHeight - 1, (y - MinY) / (MaxY - MinY) * GridHeight))
End Sub

Private Sub DrawGrid (Start As Int, EndIndex As Int)
	For x = Start To EndIndex
		For y = 0 To GridHeight-1
			If y Mod HorizontalLineGap = 0 Then
				bc.SetColor(x, y, GridColor)
			Else
				bc.SetColor(x, y, BackgroundColor)
			End If
		Next
		If (x + XZero) Mod VerticalLineGap = 0 Then
			For y = 0 To GridHeight - 1
				bc.SetColor(x, y, GridColor)
			Next
			
		End If
		Dim CenterX As Int = x + XZero - HalfVerticalLineGap
		If CenterX Mod VerticalLineGap = 0 Then
			Dim bmp As B4XBitmap = CreateTextBitmap(CenterX)
			Dim r As B4XRect
			
			r.Initialize(CenterX - XZero - bmp.Width / 2, GridHeight, CenterX - XZero + bmp.Width / 2, _
					GridHeight + bmp.Height)
			bc.DrawBitmap(bmp, r, True)
				
		End If
	Next
End Sub

Sub CreateTextBitmap(Text As String) As B4XBitmap
	cvs.DrawRect(cvs.TargetRect, BackgroundColor, True, 0)
	Dim r As B4XRect = cvs.MeasureText(Text, fnt)
	Dim BaseLine As Int = cvs.TargetRect.CenterY - r.Height / 2 - r.Top
	cvs.DrawText(Text, cvs.TargetRect.CenterX, BaseLine, fnt, xui.Color_Black, "CENTER")
	cvs.Invalidate
	Return cvs.CreateBitmap
End Sub